package inject;

import java.io.IOException;
import java.io.InputStream;
import java.util.Properties;

import com.google.inject.Binder;
import com.google.inject.Module;
import com.google.inject.Scopes;
import com.google.inject.name.Names;

public class MyModule implements Module {
	@Override
	public void configure(Binder binder) {
		binder.bind(Vehicle.class).annotatedWith(Fast.class).to(Copter.class).in(Scopes.SINGLETON);
		binder.bind(Vehicle.class).annotatedWith(Names.named("Speed")).to(AirShip.class);
		binder.requestStaticInjection(AirShip.class); 
		
		binder.bind(Energy.class).to(Fuel.class);
		binder.bind(Energy.class).annotatedWith(LightEnergy.class).to(Gas.class);
		binder.bind(Energy.class).annotatedWith(Names.named("CleanEnergy")).to(Solar.class);
		
		binder.bind(Hero.class).toProvider(HeroProvider.class);
		
		binder.bind(String.class).annotatedWith(Names.named("point1")).toInstance("0.4");
		InputStream stream = MyModule.class.getResourceAsStream("app.properties");
		Properties appProperties = new Properties();
		try {
			appProperties.load(stream);
			Names.bindProperties(binder, appProperties);
		} catch (IOException e) {
			binder.addError(e);
		}
	}
}
