package inject;

import com.google.inject.Guice;
import com.google.inject.Inject;
import com.google.inject.Injector;
import com.google.inject.Provider;
import com.google.inject.name.Named;

public class VehicleProvider implements Provider<Vehicle> {
	double point1;
	double point2;

	@Inject
	public VehicleProvider(@Named("point1") String p1, @Named("point2") String p2) {
		this.point1 = Double.parseDouble(p1);
		this.point2 = Double.parseDouble(p2);
	}

	@Override
	public Vehicle get() {
		Injector injector = Guice.createInjector(new MyModule());
		double rnd = Math.random();
		if (rnd < point1) {
			return injector.getInstance(Mobile.class);
		} else if (rnd < point2) {
			return injector.getInstance(AirShip.class);
		} else {
			return injector.getInstance(Mobile.class);
		}
	}
}